;	--	Preliminaires

#SingleInstance ignore

#NoEnv
SetBatchLines -1
ListLines Off

IfNotExist, %A_Temp%\##LvL2img		;	--	Working folder is created (if didn't existed before) within the Temp folder of the Windows OS
	FileCreateDir, %A_Temp%\##LvL2img	;	--	In that folder, there will be placed the programs and files needed for the GUI to work
A_WorkingDirectory = %A_Temp%\##LvL2img	;	--	Alias of the working folder
LastSelectedFolder = %A_ScriptDir%
SelectedOutputFolder = %A_ScriptDir%	;	--	Output folder
AllowClosingProgram:=1		;	--	This value is 0 while the program is on execution, but if the user insists in closing it, s/he can do it by clicking Yes in a confirmation window
ProgramReadyToBeUsed:=1	;	--	Program which just have started, or program just finished and with a clean list. With a value of 0, drag and drop is not allowed

;	--	Lines for the compiler

FileInstall, lvl2img.png, %A_WorkingDirectory%\lvl2img.png	;	--	Extraction of logo and auxiliary programs for the GUI to work
FileInstall, LemImageDumper.exe, %A_WorkingDirectory%\LemImageDumper.exe		;	--	LemImageDumper.exe is used to convert LVL and NXP files to images
;	--	Extraction of styles folder
FileCreateDir, %A_WorkingDirectory%\styles
FileInstall, styles\beach.dat, %A_WorkingDirectory%\styles\beach.dat
FileInstall, styles\brick.dat, %A_WorkingDirectory%\styles\brick.dat
FileInstall, styles\bubble.dat, %A_WorkingDirectory%\styles\bubble.dat
FileInstall, styles\cavelem.dat, %A_WorkingDirectory%\styles\cavelem.dat
FileInstall, styles\circuit.dat, %A_WorkingDirectory%\styles\circuit.dat
FileInstall, styles\circus.dat, %A_WorkingDirectory%\styles\circus.dat
FileInstall, styles\crystal.dat, %A_WorkingDirectory%\styles\crystal.dat
FileInstall, styles\desert.dat, %A_WorkingDirectory%\styles\desert.dat
FileInstall, styles\dirt.dat, %A_WorkingDirectory%\styles\dirt.dat
FileInstall, styles\egyptian.dat, %A_WorkingDirectory%\styles\egyptian.dat
FileInstall, styles\fire.dat, %A_WorkingDirectory%\styles\fire.dat
FileInstall, styles\highland.dat, %A_WorkingDirectory%\styles\highland.dat
FileInstall, styles\horror.dat, %A_WorkingDirectory%\styles\horror.dat
FileInstall, styles\l3_biolab.dat, %A_WorkingDirectory%\styles\l3_biolab.dat
FileInstall, styles\l3_egypt.dat, %A_WorkingDirectory%\styles\l3_egypt.dat
FileInstall, styles\l3_shadow.dat, %A_WorkingDirectory%\styles\l3_shadow.dat
FileInstall, styles\lab.dat, %A_WorkingDirectory%\styles\lab.dat
FileInstall, styles\lpiv_candy.dat, %A_WorkingDirectory%\styles\lpiv_candy.dat
FileInstall, styles\lpiv_clockwork.dat, %A_WorkingDirectory%\styles\lpiv_clockwork.dat
FileInstall, styles\lpiv_space.dat, %A_WorkingDirectory%\styles\lpiv_space.dat
FileInstall, styles\lpiv_wasteland.dat, %A_WorkingDirectory%\styles\lpiv_wasteland.dat
FileInstall, styles\lpv_abstract.dat, %A_WorkingDirectory%\styles\lpv_abstract.dat
FileInstall, styles\lpv_honeycomb.dat, %A_WorkingDirectory%\styles\lpv_honeycomb.dat
FileInstall, styles\lpv_machine.dat, %A_WorkingDirectory%\styles\lpv_machine.dat
FileInstall, styles\lpv_mineshaft.dat, %A_WorkingDirectory%\styles\lpv_mineshaft.dat
FileInstall, styles\marble.dat, %A_WorkingDirectory%\styles\marble.dat
FileInstall, styles\martian.dat, %A_WorkingDirectory%\styles\martian.dat
FileInstall, styles\medieval.dat, %A_WorkingDirectory%\styles\medieval.dat
FileInstall, styles\metal.dat, %A_WorkingDirectory%\styles\metal.dat
FileInstall, styles\nx_sketches.dat, %A_WorkingDirectory%\styles\nx_sketches.dat
FileInstall, styles\outdoor.dat, %A_WorkingDirectory%\styles\outdoor.dat
FileInstall, styles\pillar.dat, %A_WorkingDirectory%\styles\pillar.dat
FileInstall, styles\polar.dat, %A_WorkingDirectory%\styles\polar.dat
FileInstall, styles\psychedelic.dat, %A_WorkingDirectory%\styles\psychedelic.dat
FileInstall, styles\purple.dat, %A_WorkingDirectory%\styles\purple.dat
FileInstall, styles\rock.dat, %A_WorkingDirectory%\styles\rock.dat
FileInstall, styles\sega.dat, %A_WorkingDirectory%\styles\sega.dat
FileInstall, styles\shadow.dat, %A_WorkingDirectory%\styles\shadow.dat
FileInstall, styles\sky.dat, %A_WorkingDirectory%\styles\sky.dat
FileInstall, styles\snow.dat, %A_WorkingDirectory%\styles\snow.dat
FileInstall, styles\space.dat, %A_WorkingDirectory%\styles\space.dat
FileInstall, styles\special.dat, %A_WorkingDirectory%\styles\special.dat
FileInstall, styles\sports.dat, %A_WorkingDirectory%\styles\sports.dat
FileInstall, styles\tree.dat, %A_WorkingDirectory%\styles\tree.dat
FileInstall, styles\xmas.dat, %A_WorkingDirectory%\styles\xmas.dat

;	--	GUI creation

#include createGUI.ahk

; -- CONVERSION PROCESS

#include LVLConversion.ahk	;	--	Code for converting LVL files via console program

Begin:
if(LV_GetCount()=0)	;	--	Counter of files dragged and dropped to the list
{
	MsgBox, 8192, Begin conversion, No files on the list.	; 8192 = System modal: the current window has focus priority over the rest
}
else
{
	DeactivateInteractionControls()	;	--	Deactivate checking boxes and buttons from the GUI
	ProgramReadyToBeUsed:=0		;	--	No more drag and drop to the window will be allowed
	ShowProgressControls()	;	--	Show progress bar
	AllowClosingProgram:=0	;	--	Can be turned to 1 if user insists on closing program, via Esc or window X (closing) button
	stepTotal:=0	;	--	Status of progress bar
	StepTotalArchives:=(100/LV_GetCount())	;	--	How thick will be each step in the progress bar (once a file is processed)
	Loop % LV_GetCount()	;	--	Loop through the rows of the list of files
	{
		CurrentRow:=A_Index		;	--	Current row of the list of files
		LV_GetText(CurrentFile, CurrentRow)	;	--	Get route to the current archive on the list
		if(SelectedOutputFolder="Same")	;	--	If the checkbox of the output folder is checked, then each processed file will be placed in the same folder as the original
		{
			SplitPath, CurrentFile, , OutputFolder	;	--	Get the folder route of the current archive to process
			OutputFolder=%OutputFolder%\	;	--	Add a final backslash, in order to fix a bug that happens when the OutputFolder is a simple unit letter with a colon
		}
		else
		{
			OutputFolder:=SelectedOutputFolder	;	--	If the checkbox is not checked, the output folder will be the selected by the user (by default is the folder of LvL2img script)
		}
		FileGetSize, SizeOfOriginalFile, %CurrentFile%, K
		SizeOfFileConverted:=0		;	--	This value will be gotten after the compression
		SplitPath, CurrentFile, NameOfCurrentFileWithExtension, NameOfCurrentFileFolder, ExtensionOfCurrentFile, NameOfCurrentFileWithoutExtension	;	--	Get info about the current file to process
		
		GoSub LVLConversion		;	--	Jump to label in charge of LVLConversion code
		
		LV_Modify(CurrentRow, "Col4" "Vis" , "Moving " CurrentFileConverted )
		MsgBox %RouteOfCurrentFileConverted% %OutputFolder%
		FileMove, %RouteOfCurrentFileConverted%, %OutputFolder%, 1	; -- Move file to output folder
		LV_Modify(CurrentRow, "Col4" "Vis" , "Conversion finished")
		LV_Modify(CurrentRow, "Col3" "Vis" , SizeOfFileConverted " KB")
		FinalPercentage:=Round((SizeOfFileConverted/SizeOfOriginalFile)*100)	;	--	Calculation of converted file size savings/gains in %
		LV_Modify(CurrentRow, "Col4" "Vis" , "Archive converted (" . FinalPercentage . " `%)")
		stepTotal:=stepTotal+StepTotalArchives	;	--	Update variable of progress bar status
		GuiControl,, TotalProgress, %stepTotal%		;	--	Refresh progress bar
	}
	AllowClosingProgram:=1
	GuiControl, Enable, CleanListButton		;	--	After conversion/compression finishes, this two controls are activated again - the user can only clean the list of processed files before using again the program
	GuiControl, Enable, ListOfCurrentFiles
}
return